<?php
if(!defined('__FUNCS_PHP__'))
{
	define('__FUNCS_PHP__', 1);

	// Form --> HTML
	function preparer_donnees( &$auteur, &$texte )
	{
    // protection JS
		$auteur = str_replace('<', '&lt;', $auteur);
    $texte = str_replace('<', '&lt;', $texte);
    
    $texte = nl2br($texte);

    // on remplace les <g> et les </g> par des <b> et par des </b>
		$array_search[] = '[g]';
		$array_search[] = '[/g]';
		$array_replace[] = '<span class="form_b">';
		$array_replace[] = '</span>';
    
    // on remplace les <s> et les </s> par des <u> et pars des </u>
		$array_search[] = '[s]';
		$array_search[] = '[/s]';
		$array_replace[] = '<span class="form_u">';
		$array_replace[] = '</span>';
    
		// italique
		$array_search[] = '[i]';
		$array_search[] = '[/i]';
		$array_replace[] = '<span class="form_i">';
		$array_replace[] = '</span>';
    
    // on remplace les <liste> par des <ul type='disc'> et le </liste> par des </ul>
		$array_search[] = '[liste]';
		$array_search[] = '[/liste]';
		$array_replace[] = '<ul type="disc">';
		$array_replace[] = '</ul>';
    
    // on remplace les [li] et les [/li] par des <li> et pars des </li>
		$array_search[] = '[li]';
		$array_search[] = '[/li]';
		$array_replace[] = '<li>';
		$array_replace[] = '</li>';
    
    // on enlve les <br> avant les nouvelles lignes de listes
		$array_search[] = '<br /><li>';
		$array_search[] = '</li><br />';
		$array_search[] = '<br /><ul type="disc">';
		$array_search[] = '<br /></ul>';
		$array_replace[] = '<li>';
		$array_replace[] = '</li>';
		$array_replace[] = '<ul type="disc">';
		$array_replace[] = '</ul>';
    
    // pour les smileys    
    $rep = opendir('images/smileys');
    while($fichier = readdir($rep))
    {
			if(substr($fichier, -3) != 'gif')
				continue;
            
     $array_search[] = ':' . $nom = substr($fichier, 0, strlen($fichier) - 4) . ':';
     $array_replace[] = '<img src="images/smileys/' . $fichier . '" align="middle">';
		}
    closedir($rep);
    
    // remplacement du nom de la couleur par le code de la couleur                            
    $texte = preg_replace('/\[[ ]?couleur[ ]?=[ ]?blanc[ ]?\]/i', '[couleur="#FFFFFF"]', $texte);
    $texte = preg_replace('/\[[ ]?couleur[ ]?=[ ]?bleu[ ]?\]/i', '[couleur="#0000FF"]', $texte);
    $texte = preg_replace('/\[[ ]?couleur[ ]?=[ ]?bleu_f[ ]?\]/i', '[couleur="#0E05A9"]', $texte);
    $texte = preg_replace('/\[[ ]?couleur[ ]?=[ ]?cyan[ ]?\]/i', '[couleur="#68D1F9"]', $texte);
    $texte = preg_replace('/\[[ ]?couleur[ ]?=[ ]?jaune[ ]?\]/i', '[couleur="#FFFF00"]', $texte);
    $texte = preg_replace('/\[[ ]?couleur[ ]?=[ ]?noir[ ]?\]/i', '[couleur="#000000"]', $texte);
    $texte = preg_replace('/\[[ ]?couleur[ ]?=[ ]?orange[ ]?\]/i', '[couleur="#F3C061"]', $texte);
    $texte = preg_replace('/\[[ ]?couleur[ ]?=[ ]?rose[ ]?\]/i', '[couleur="#FD8AEC"]', $texte);
    $texte = preg_replace('/\[[ ]?couleur[ ]?=[ ]?rouge[ ]?\]/i', '[couleur="#FF0000"]', $texte);
    $texte = preg_replace('/\[[ ]?couleur[ ]?=[ ]?vert[ ]?\]/i', '[couleur="#00FF00"]', $texte);
    $texte = preg_replace('/\[[ ]?couleur[ ]?=[ ]?vert_f[ ]?\]/i', '[couleur="#749962"]', $texte);
    
    // replacement du nom de taille par le code de taille
    $texte = preg_replace('/\[[ ]?taille[ ]?=[ ]?t_petit[ ]?\]/i', '[taille="8"]', $texte);
    $texte = preg_replace('/\[[ ]?taille[ ]?=[ ]?petit[ ]?\]/i', '[taille="10"]', $texte);
    $texte = preg_replace('/\[[ ]?taille[ ]?=[ ]?moyen[ ]?\]/i', '[taille="13"]', $texte);
    $texte = preg_replace('/\[[ ]?taille[ ]?=[ ]?grand[ ]?\]/i', '[taille="18"]', $texte);
    $texte = preg_replace('/\[[ ]?taille[ ]?=[ ]?t_grand[ ]?\]/i', '[taille="21"]', $texte);
    
    // pour les mails
    $texte = preg_replace('/\[mail\]([^<]+)\[\/mail\]/i', '<a href="mailto:\1">\1</a>', $texte);
    
		// pour les url
    $texte = preg_replace('/\[url\]([^<]+)\[\/url\]/i', '<a href="\1" target="_blank">\1</a>', $texte);
		$texte = preg_replace('/\[url=([^\]]+)\]([^<]+)\[\/url\]/i', '<a href="\2" target="_blank">\1</a>', $texte);
		
		// protection des urls ( js )
		$texte = preg_replace( '/<a href="[ ]?javascript:([^<]+)"([^<]+)>([^<]+)<\/a>/i', '', $texte );
		
		// pour les citations
    $texte = preg_replace('/\[quote nom[ ]?=[ ]?([^<]+)\](.*?)\[\/quote\]/si',"<table class='quote'><tr><td class='quote_title'><span class='quote'>\\1 a dit:</span></td></tr><tr><td class=\"quote\">\\2</td></tr></table>", $texte);
    $texte = preg_replace('/\[quote nom[ ]?=[ ]?\](.*?)\[\/quote\]/si',"<table class='quote'><tr><td class='quote_title'><span class='quote'>Citation:</span></td></tr><tr><td class=\"quote\">\\1</td></tr></table>", $texte);
		$texte = preg_replace('/\[quote[ ]?\](.*?)\[\/quote\]/si',"<table class='quote'><tr><td class='quote_title'><span class='quote'>Citation:</span></td></tr><tr><td class=\"quote\">\\1</td></tr></table>", $texte);
		
    // images
    $texte = preg_replace('/\[img\]http:\/\/([[:alnum:]\.\/\-_]+(\.jpg|\.jpeg|\.gif|\.png))\[\/img\]/i', '<a href="http://\\1" target="_blank"><img src="http://\\1" alt="" border="0"></a>', $texte); 

    $texte = preg_replace('/\[couleur[ ]?=[ ]?["]?([#ABCDEF0-9]+)["]?[ ]?\]/i','<span style="color: \1;">', $texte); 
    $texte = preg_replace('/\[taille[ ]?=[ ]?"([01238]{1,2})"\]/i','<span style="font-size: \1px;">', $texte);
    
		$array_search[] = '[/couleur]';
		$array_search[] = '[/taille]';
		$array_replace[] = '</span>';
		$array_replace[] = '</span>';
		
		$texte = str_replace( $array_search, $array_replace, $texte);
		
		$count_span_open = preg_match_all('/<span([[:alnum:] ";:\-]*)/i', $texte, $matches);
		$count_span_close = preg_match_all('/<\/span>/i', $texte, $matches);
		
		for(; $count_span_close < $count_span_open; $count_span_close++)
			$texte .= '</span>';
			
		$texte = addslashes($texte);
		$auteur = addslashes($auteur);
	}
	
	// HTML --> Form
	function unpreparer_donnees( &$auteur, &$texte )
	{
		$texte = stripslashes( $texte );
		$auteur = stripslashes( $auteur );
		
		// <span style="color: #XXXXXX;"> ---> [couleur="XXXXXX"]
		$texte = preg_replace('/<span style="color:[ ]?#([0-9ABCDEF]{6})[;]?">(.*?)<\/span>/is', '[couleur="#\\1"]\\2[/couleur]', $texte);
		// <span style="font-size: XXpx;"> --> [taille="XX"]
		$texte = preg_replace('/<span style="font\-size:[ ]?([01238]{1,2})px[;]?">(.*?)<\/span>/si', '[taille="\\1"]\\2[/taille]', $texte);
		
		// <a href="XXX" target="_blank">XXX</a> --> [url]XXX[/url]
		$texte = preg_replace('/<a href="([^<]+)" target="_blank">([^<]+)<\/a>/i', '[url=\\2]\\1[/url]', $texte);
		// <a href="mailto: XXX">XXX</a>
		$texte = preg_replace('/<a href="mailto:([^<]+)">([^<]+)<\/a>/i', '[mail]\\2[/mail]', $texte);
		
		// <span style="font-weight: bold;">XXX</span> [g]XXX[/g]
		$texte = preg_replace('/<span class="form_b">(.*?)<\/span>/is', '[g]\\1[/g]', $texte);
		// <span style="text-decoration: underline;">XXX</span> [s]XXX[/s]
		$texte = preg_replace('/<span class="form_u">(.*?)<\/span>/is', '[s]\\1[/s]', $texte);
		// <span style="font-style: italic;">XXX</span> [s]XXX[/s]
		$texte = preg_replace('/<span class="form_i">(.*?)<\/span>/is', '[i]\\1[/i]', $texte);
		
		// listes
		$texte = preg_replace('/<ul type="disc">(.*?)<\/ul>/is', '[liste]\\1[/liste]', $texte);
		$texte = preg_replace('/<li>(.*?)<\/li>/is', '[li]\\1[/li]', $texte);
		
		// citations
		$texte = preg_replace('/<table class=\'quote\'><tr><td class=\'quote_title\'><span class=\'quote\'>(.*?) a dit:<\/span><\/td><\/tr><tr><td class="quote">(.*?)<\/td><\/tr><\/table>/is', '[quote nom=\\1]\\2[/quote]', $texte);
		$texte = preg_replace('/<table class=\'quote\'><tr><td class=\'quote_title\'><span class=\'quote\'>Citation:<\/span><\/td><\/tr><tr><td class="quote">(.*?)<\/td><\/tr><\/table>/is', '[quote]\\1[/quote]', $texte);
		
		$array_search = array('<br />', '\n',
			'[taille="8"]', '[taille="10"]', '[taille="13"]', '[taille="18"]', '[taille="21"]',
			'[couleur="#FFFFFF"]', '[couleur="#0000FF"]', '[couleur="#0E05A9"]', '[couleur="#68D1F9"]', '[couleur="#FFFF00"]', '[couleur="#000000"]',
			'[couleur="#F3C061"]', '[couleur="#FD8AEC"]', '[couleur="#FF0000"]', '[couleur="#00FF00"]', '[couleur="#749962"]'
		);
		
		$array_replace = array('', '',
			'[taille=t_petit]', '[taille=petit]', '[taille=moyen]', '[taille=grand]', '[taille=t_grand]',
			'[couleur=blanc]', '[couleur=bleu]', '[couleur=bleu_f]', '[couleur=cyan]', '[couleur=jaune]', '[couleur=noir]',
			'[couleur=orange]', '[couleur=rose]', '[couleur=rouge]', '[couleur=vert]', '[couleur=vert_f]'
		);
		
		// pour les smileys    
    $rep = opendir('images/smileys');
    while($fichier = readdir($rep))
    {
			if(substr($fichier, -3) != 'gif')
				continue;
       
			$array_search[] = '<img src="images/smileys/' . $fichier . '" align="middle">';
			$array_replace[] = ':' . $nom = substr($fichier, 0, strlen($fichier) - 4) . ':';
		}
    closedir($rep);
		
		$texte = str_replace($array_search, $array_replace, $texte);
	}
}
?>
